/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package setup;

import core.LufBoard;
import core.LufBoardEvent;
import java.util.LinkedList;
import java.util.List;

/**

 @author reidl
 */
public abstract class BoardBuilder {
    protected int numPlayers = -1;
    protected List<LufBoardEvent.Visitor> visitors = new LinkedList<LufBoardEvent.Visitor>();

    public BoardBuilder() {
    }

    public BoardBuilder addVisitor(LufBoardEvent.Visitor visitor) {
        visitors.add(visitor);
        return this;
    }
    
    protected void addVisitorsToBoard(LufBoard board) {
        for (LufBoardEvent.Visitor visitor : visitors) {
            board.addVisitor(visitor);
        }        
    }

    public abstract LufBoard build();

    public BoardBuilder setNumPlayers(int numPlayers) {
        this.numPlayers = numPlayers;
        return this;
    }
}
